import { Type } from '@angular/core';
import { ComponentFixture } from '@angular/core/testing';
import { MockMapper, TestSuite } from 'suite-slimmer';
export declare type AngularTestCallback<T> = (classInstance: T, mocks: MockMapper, fixture: ComponentFixture<T>) => void;
export declare type AngularTestSuiteType = 'component' | 'service';
export declare class AngularTestSuite<TClass> extends TestSuite<TClass> {
    readonly classType: Type<TClass>;
    readonly testType: AngularTestSuiteType;
    private fixture;
    private resetTestingModule;
    constructor(classType: Type<TClass>, testType: AngularTestSuiteType, excludeOthers?: boolean);
    addTest(description: string, callback: AngularTestCallback<TClass>, excludeOthers?: boolean): this;
    protected initializeTest(mockMapper: MockMapper, declarations: any[], imports: any[], providers: any[]): Promise<TClass>;
    protected initializeTests(mockMapper: MockMapper, declarations: any[], imports: any[], providers: any[]): Promise<void>;
    protected disposeTests(): Promise<void>;
}
